# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventGrid::V2018_01_01
  module Models
    #
    # Schema of the Data property of an EventGridEvent for a device connection
    # state event (DeviceConnected, DeviceDisconnected).
    #
    class DeviceConnectionStateEventProperties

      include MsRestAzure

      # @return [String] The unique identifier of the device. This
      # case-sensitive string can be up to 128 characters long, and supports
      # ASCII 7-bit alphanumeric characters plus the following special
      # characters: - : . + % _ &#35; * ? ! ( ) , = @ ; $ '.
      attr_accessor :device_id

      # @return [String] The unique identifier of the module. This
      # case-sensitive string can be up to 128 characters long, and supports
      # ASCII 7-bit alphanumeric characters plus the following special
      # characters: - : . + % _ &#35; * ? ! ( ) , = @ ; $ '.
      attr_accessor :module_id

      # @return [String] Name of the IoT Hub where the device was created or
      # deleted.
      attr_accessor :hub_name

      # @return [DeviceConnectionStateEventInfo] Information about the device
      # connection state event.
      attr_accessor :device_connection_state_event_info


      #
      # Mapper for DeviceConnectionStateEventProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DeviceConnectionStateEventProperties',
          type: {
            name: 'Composite',
            class_name: 'DeviceConnectionStateEventProperties',
            model_properties: {
              device_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'deviceId',
                type: {
                  name: 'String'
                }
              },
              module_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'moduleId',
                type: {
                  name: 'String'
                }
              },
              hub_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'hubName',
                type: {
                  name: 'String'
                }
              },
              device_connection_state_event_info: {
                client_side_validation: true,
                required: false,
                serialized_name: 'deviceConnectionStateEventInfo',
                type: {
                  name: 'Composite',
                  class_name: 'DeviceConnectionStateEventInfo'
                }
              }
            }
          }
        }
      end
    end
  end
end
